/********************************************/
/*	T[~X^ 103JTgxv			*/
/*		12bit A/DRo[^4ch		*/
/*		VAŃf[^o				*/					
/********************************************/
//	"tn84_thm4ch1.c"
//	2022-11-01	Jn
//	2023-03-10	1 2
//	AVR studio 4.19găvO
//		Program:    7750 bytes (94.6% Full)
//			(.text + .data + .bootloader)
//		Data:        178 bytes (34.8% Full)
//			(.data + .bss + .noinit)
//	ATtiny84 18.432MHz ONbNœ
//			ROM:8k  RAM:512  EEPROM:512
//	ADC̓}CN`bvMCP3204 4ch 12bit
//					Vref1.25V (LM317L)
//  	PA0  in  AREF A/Dd 4.096V MCP1541
//      PA1  in  ADC1 A/D Aϊ
//      PA2  out ADC DIN (ADCւ̃R}h) 
//      PA3  out ADC CLK
//      PA4  out TXD VAf[^o(^C}[荞݂ŏo)
//      PA5  in  LœdA/DlƒRlt
//      PA6  out OC1A 4.8kHzo
//      PA7  out ADC /CS 
//      PB0  -   X1 XTAL 18.432MHz
//      PB1  -   X2 XTAL
//      PB2  in  ADC DOUT (ADC̃f[^)
//      PB3  -   (RESET)
//	Fuse : 	Ext : 0xFF
//			  H : 0xDC 11011100
//					   |||||+++----	BOD 4.3V
//					   ||||+-------	EESAVE
//					   |||+--------	WDTON
//					   ||+---------	SPIEN
//					   |+----------	DWEN
//					   +-----------	RSTDISBL
//			  L : 0xFF 11111111
//				       ||||++++----	CKSEL OXTAL
//					   ||++--------	SUT   64ms slow up
//					   |+----------	CKOUT  Ȃ
//					   +-----------	CKDIV8 Ȃ
//	T[~X^(103JT) Rs=10k1.25VɃvAbv
//	A/Dl(0`4095)x(-20.0`120.0)ɕϊ
//	VAo 9600BPSŃf[^M
//	01234567890123456789012345678901234  35+CR+LF
//	123456 -12.3 111.1 -10.9  36.8 4.01
//	  |      |     |     |     |    +----- AD1  d 0.01V
//	  |      |     |     |     +---------- THM4 x 0.1
//	  |      |     |     +---------------- THM3 x
//	  |      |     +---------------------- THM2 x
//	  |      +---------------------------- THM1 x
//	  +----------------------------------- 1bJE^
//	     					               6F11
//	d10bitA/DŌvZĂ̂Ŗ4mVŏ
//	A/Dl̐`⊮ LoHi̎lZbg 1
//	_lR 4Rs̒lZbg		 2
//	INP_JP1(PA5Wp)on(L)Ȃ
//	A/Df[^`FbN̂A/DlƒRl
//	VAo͂ɉ (3sɂďo)
/*****	CN[ht@C	*****/
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
//	^Cg                     0 1234567890123456789012345 6 7
const char msg_ttl[] PROGMEM = "\r\n# 103JT 4ch+V 2023-03-11\r\n";
/*****	}N		*****/
//	f[^TCY
typedef uint8_t   byte;
typedef uint16_t  word;
//	op-code
#define nop()       asm volatile("nop"  "\n\t")	// NOPR[h
void wait(void){ nop(); }						// ԑ҂
//  z̃f[^Ԃ}N
#define DIMSIZ(a)   (sizeof(a)/sizeof(*a))
//	f[^w
#define CR		0x0d		// A
#define LF		0x0a		// s
//	in/out
#define INP_JP1    	((~PINA) & (1 << PORTA5))	// JP1 Lon
#define PA6_H      	(PORTA |=  (1 << PA6))      // (!!!) eXgpX
#define PA6_L      	(PORTA &= ~(1 << PA6))		// 7pin H/L

/********************************/
/*		A/Dl␳				*/	
/********************************/
//	A/Dchw
#define	AD_CH4		4			// 10bit A/D:ADC1
//  A/D␳p[^
//	x0x1Ɏlݒ肷
//	y0y1͖ڕWl(vZl)ݒ
//	Rs = 10k 1k30k̒Rg
//		Lo  1k(99)   y0=372.3  4096*( 1/(10+ 1))
//	@	Hi 30k(-1.8) y1=3072   4096*(30/(10+30))
//	邢͓d̎l  Vref=1.2496V
//		Lo  1k Vin=0.1136V  Vin*4096/Vref=372.4
//		Hi 30k Vin=0.9364V  Vin*4096/Vref=3069.4
//	ch4̓}CRA/D10bitl ADC1
//	Arefl(MCP1541:4.096V)tXP[
//	ẐȂ0.1V4.0V  AreflɊ֌WȂϊł
const struct{
	const word  x0;		// in  min (Lo)  A/Df[^
	const word  x1;		// in  max (Hi)   V
	const word  y0;		// out min       ڕWl(vZl)
	const word  y1;		// out max         10{lZbg
}adj_tbl[] PROGMEM = {  // 1 l  85E25̒R
	{ 515, 2043,  5187, 20467 },	// A/D ch0 THM1
	{ 515, 2043,  5187, 20467 },	// A/D ch1 THM2
	{ 515, 2043,  5187, 20467 },	// A/D ch2 THM3
	{ 515, 2043,  5187, 20467 },	// A/D ch3 THM4
	{   0, 1024,     0,  4090 },	// A/D ch4 AD1(10bit A/D)
//	     |    |      |      +----	y1 \l Hi
//	     |    |      +-----------	y0 \l Lo
//	     |    +------------------	x1 A/Df[^ Hi
//	     +-------------------------	x0 A/Df[^ Lo
};
/*****  T[~X^xARe[u    *****/
// 	RsR (Vref֐ڑ)
// 	OtA/Dch 1Pʂ
//	ch0`ch34ch ch4͓A/Dœdf[^
const word rs_tbl[] PROGMEM ={
		10000,		// A/D ch0 THM1  2 l
		10000,		// A/D ch1 THM2
		10000,		// A/D ch2 THM3
		10000,		// A/D ch3 THM4
};
/*****  `        *****/
//	float
float mapf(float x, float in_min, float in_max, float out_min, float out_max)
{
	return (x - in_min) * (out_max - out_min) / (in_max - in_min) + out_min;
}
/*****	A/Dl␳		*****/
//	in ad : 0`4095 A/Dl(12bit)
//	   ch : 0`3   thm1`4
//	out_min,out_max10{l
//	ľܓ12bit͈̔͂Ń^[
//	AD_CH4͓A/DȂ̂10bit
//	  10mVPʂ̓dlɃXP[Oă^[
word adadj(word ad, byte ch)
{
float a;
short g;
	a = mapf((float)ad,			// `ԓ̓f[^
			 (float)pgm_read_word(&adj_tbl[ch].x0),	  // in_min
			 (float)pgm_read_word(&adj_tbl[ch].x1),	  // in_max
			 (float)pgm_read_word(&adj_tbl[ch].y0),	  // out_min
			 (float)pgm_read_word(&adj_tbl[ch].y1));  // out_max
	g = (short)lround(a / 10.0);	// 1/10Ăľܓ
	if(g < 0)			g = 0;		// }CiX0
	else{							// vX̎
	  if(ch == AD_CH4){				// ch4 10bit A/D
		if(ad == 0)		g = 0;		// A/Dl0Ȃ0
	  }
	  else{							// ch0`3max 12bit
	 	if(g > 4095)	g = 4095;	// ő4095ŋK (ch4͂̂܂)
	  }
	}
	return g;					// wordŃ^[
}

/****************************/
/*		T[~X^f[^	*/
/****************************/
//	Rl̍ő(x)ƍŏ(x)
float rt_max;		// CjVthm_103JT[0].ohmZbg
float rt_min;		// thm_103JT[16].ohmZbg
// Z~ebN 103JT
//		xARA   B萔
const struct{
    const int   temp;    	// x
    const float ohm;    	// R
    const float bconst;    	// B萔
}thm_103JT[] PROGMEM ={
    {  -20,   71020.0,  3239.6 },    //  0
    {  -10,   43670.0,  3272.2 },    //  1
    {    0,   27700.0,  3303.9 },    //  2
    {   10,   18070.0,  3322.1 },    //  3
    {   20,   12110.0,  3346.6 },    //  4
    {   25,   10000.0,  3366.1 },    //  5
    {   30,    8301.0,  3385.5 },    //  6
    {   40,    5811.0,  3414.0 },    //  7
    {   50,    4147.0,  3446.3 },    //  8
    {   60,    3011.0,  3463.5 },    //  9
    {   70,    2224.0,  3486.2 },    // 10
    {   80,    1668.0,  3525.6 },    // 11
    {   85,    1451.0,  3527.3 },    // 12
    {   90,    1267.0,  3545.8 },    // 13
    {  100,     975.3,  3571.8 },    // 14
    {  110,     759.7,  3602.7 },    // 15
    {  120,     598.1,  3601.8 },    // 16
};
/******************************/
/*      xvZ              */
/******************************/
//  Rlr,oCiT[`jAT[`
#define  B_SEARCH  1    // 1ȂoCiT[`ŒRT[`
                        // 0Ȃ烊jAT[`
//	vZpf[^
#define  K273      273.15       // Prx

/*****  A/DlT[~X^RlRt    *****/
//	d  : 12bit A/Dl0`4095
//	ch : ch敪 0`3  (ch4͓A/Dœdl)
//    Ad  : A/Dl 12bit 0`4095
//    Ar  : A/D   12bit 4096
//    Rs  : R 10k
//	  Rt  : T[~X^Rl  ch0`ch3 e[uǂݏo
//        Rt = Rs / ((Ar/Ad) - 1)
//           = (Rs * Ad) / (Ar - Ad)
float rthm(word d, byte ch)
{
	return (((float)pgm_read_word(&rs_tbl[ch]) * 
	         (float)d) / (float)(4096 - d));
}
/*****  肵RlƃT[~X^RlƔr  *****/
//      ohm:Rl  n:zԍ
//      ^[l@0=v : t[n]`t[n+1])͈͓̔
//        +1:Rl : x
//        -1:Rl傫 : xႢ
int8_t thcomp(float ohm, byte n)
{
float r1,r2;
    r1 = pgm_read_float(&thm_103JT[n].ohm);    // wz
    if(n < (DIMSIZ(thm_103JT) - 1))            // Ō:x
        r2 = pgm_read_float(&thm_103JT[n+1].ohm);
    else
        r2 = r1;                 // n+1̂n̒l
    if(n == 0){                  // 擪=x
      if(ohm > r1)		  return 0;
    }  
    if(n == (DIMSIZ(thm_103JT) - 1)){   // Ō:x
      if(ohm <= r2)       return 0;
    }
    if(ohm > r1)          return -1;    // x
    else  if(ohm <= r2)   return 1;     // x
    else                  return 0;     // ͈͓
}
/*****  T[~X^RlƃoCiT[`    *****/
//    in      r:肵Rl
//    ret     n:T[~X^zԍ
byte thmsearch(float r)
{
byte n1, n2, nc;
int8_t  ck;
#if B_SEARCH == 1   // oCi[T[`
    n1 = 0;                     	// 擪 x
    n2 = DIMSIZ(thm_103JT) - 2;     // Ō x(n+1c)
    while(n1 <= n2){
        nc = (n1 + n2) / 2;     // 
        ck = thcomp(r, nc);     // Rr
        if(ck > 0)         n1 = nc + 1;   
        else if(ck < 0)    n2 = nc - 1;   
        else              break;         // OK
    }    
#else   // jAT[`
    for(nc = 0; nc < (DIMSIZ(thm_103JT) - 2); nc++){
        if( r  > pgm_read_float(&thm_103JT[nc].ohm))     break;
        if((r <= pgm_read_float(&thm_103JT[nc].ohm)) &&
           (r  > pgm_read_float(&thm_103JT[nc+1].ohm)))  break;
    }
#endif
    return nc;                  // vzԍ
}
/*****  xvZ      *****/
//      ohm : 肵Rl
//      n   : T[~X^f[^̔zԍ
//      ret : 0.1xPʂ̉x()    -123-12.3
short tempcalc(float ohm, int n)
{
float t0;
float r0;
float bc;
float t;
    t0 = ((float)(int)pgm_read_word(&thm_103JT[n].temp)) + K273;  //\
    r0 = pgm_read_float(&thm_103JT[n].ohm);
    bc = pgm_read_float(&thm_103JT[n].bconst);
    t  = (1 / (log(ohm / r0) / bc + (1 / t0))) - K273;
	return	(short)lround(t * 10.0);	// 0.1PʂɂĎľܓ
}

/****************************/
/*		`^c        	*/
/****************************/
//	1msTCN1chϊ
//	1ms * 4ch * 250 = 1000ms
//	1bԊuŃf[^o
/*****  I/O}N    *****/
#define ADCS_H      (PORTA |=  (1 << PA7))      // A/D /CS
#define ADCS_L      (PORTA &= ~(1 << PA7))
#define ADDI_H      (PORTA |=  (1 << PA2))      // A/D DIN
#define ADDI_L      (PORTA &= ~(1 << PA2))
#define ADCLK_H     (PORTA |=  (1 << PA3))      // A/D CLK
#define ADCLK_L     (PORTA &= ~(1 << PA3))
#define INP_ADDO    (PINB & (1 << PORTB2))      // A/D DOUT
/*****  5ch A/Df[^      *****/
//	ch0`312bit
//	AD_CH4͓A/D10bit, d
#define  AD_SU		5       	// A/D ch 5ch (ch0`ch3:12bit, ch4:10bit)
#define  AD_SMZ		200         // ω
volatile byte     	ad_ch;            	// A/Dch 0`4
volatile byte     	ad_cnt;           	// ωZJE^
volatile word 		ad_now[AD_SU];  	// A/Df[^
volatile uint32_t 	ad_add[AD_SU];  	// ωZl
volatile word     	ad_avr[AD_SU];  	// ϒl(vZ) 0`4095
volatile byte     	f_adok;           	// ϒlmtO
										// 1bƂon
/*****  chw(0`4)A/Df[^    *****/
//  ret:12bitl 0`4095  ch4͓A/DȂ̂10bit(1023)
//  nopŎԒ
//	/CSL̎:20`23us
//	CLK  L:0.6us  H:0.5us
word adinp(byte ch)
{
word d;     // 12bitf[^
byte i;     // 6bit+12bitJE^[
	if(ch == AD_CH4){			// ch4͓ADC10bit
	  d = ADCW;					// 10bit f[^
	}
	else{						// OtA/D 4ch
      ADCLK_L;					// CLK=L
	  ADDI_H;					// DIN=H
	  wait();
      ADCS_L;                            // CS=LŊJn
//  start,single/diff,d2,d1,d0,0
      ch = 0xC0 | (ch << 3);    // 110xx000
      for(i = 0; i < 6; i++){
        if(ch & 0x80)       ADDI_H;     // MSBADDIN on/off
        else                ADDI_L;
        ch <<= 1;                       // Vtg
		nop();
        ADCLK_H;                        // CLK H/L
	    wait();
        ADCLK_L;
      }
//  data 12bit
      d = 0;
      for(i = 0; i < 12; i++){         	// 12bit loop
        ADCLK_H;                        // CLK H/L
	    wait();
        ADCLK_L;
        d <<= 1;                        // Vtg
		nop();
        if(INP_ADDO)    d |= 1;         // LSB1/0
      }
      ADCS_H;                           // CLK=L,CS=Hł
	  wait();
  	  ADDI_H;							// DIN=H
	}
    return d;
}
/*****  A/Df[^Ϗ     *****/
//  1ms5chɓǂ200ŕϒlZo
//  5*200 = 1b5ch̕σf[^m
//  f_adokon
void adavr(void)
{
word d;			// 12bit A/Dl 0`4095
uint32_t g;		// όvZp
byte i;
    d = adinp(ad_ch);          		// 12bit A/Dl (ch4 10bit̓A/D)
	ad_now[ad_ch] = d;				// f[^
    d *= 10;          				// ľܓp10{ 0`40950(16bit)
    ad_add[ad_ch] += (uint32_t)d;   // 32bitŉZ
    ad_ch++;                        // ch
    if(ad_ch >= AD_SU){           	// 0`3,4
      ad_ch = 0;					// 5ch0ɖ߂
      ad_cnt++;                   	// ω+1
      if(ad_cnt >= AD_SMZ){    		// 200
        ad_cnt = 0;
        for(i = 0; i < AD_SU; i++){  	// 5ch loop            
		  g = ad_add[i] / AD_SMZ;  		// ϒl(x10܂܂)
		  d = (word)((g + 5) / 10);		// 1/10,ľܓ
          ad_avr[i] = d;				// ϒlZ[u
          ad_add[i] = 0;                // Z[NA
        }
        f_adok = 1;        	// 1bŕϒlm
      }
    }
}

/********************************/
/*		VAo			*/
/********************************/
/*****	^C}[荞݂gVAo	*****/
#define	TX_H	(PORTA |=  (1 << PA4))  // TXD PA4 9pin
#define	TX_L	(PORTA &= ~(1 << PA4))
//	Mf[^
volatile byte tx_exc;		// Ms敪
							// 0:X^oC 1`4s
volatile byte tx_chr;		// M 8bit LSBo
volatile byte tx_bit;		// MbitJE^
#define	 TX_SIZ		64		// Mobt@̃oCg
volatile char tx_bff[TX_SIZ];	// Mobt@
volatile byte tx_cnt;			// 
volatile byte tx_wrp;			// ݃|C^
volatile byte tx_rdp;			// ǂݏo|C^
/*****	1M		*****/
//	MɂȂ܂ő҂1o(obt@)
//	s̓^C}[荞݂
void tx(char c)
{
	while(tx_cnt >= TX_SIZ);	// obt@ς	
	cli();						// 񊄍֎~
	tx_bff[tx_wrp] = c;			// obt@1
	tx_wrp++;
	if(tx_wrp >= TX_SIZ)	tx_wrp = 0;	// |C^?
	tx_cnt++;							//  +1
	sei();						// 荞ݍĊJ
}
/*****	CR,LFo		*****/
void txcrlf(void)
{
	tx(CR);		// s
	tx(LF);
}
/*****	o	****/
//	nullI[  1
void txstr(char *s)
{
	while(*s){				// nullłȂ
		tx(*s);				// 1M
		s++;				// 
	}
}
/*****	progmmemo	****/
//	nullI[  1
void txstr_P(const char *s)
{
char c;
	while(1){
		c = pgm_read_byte(s);		// 1ǂݏo
		if(c == '\x0')		break;	// nullŏI
		tx(c);						// 1M
		s++;						// 
	}
}
/*****	wBCDo		*****/
static char b_bff[18];		// 18(nullꂸ)
//	n: p:
//	l͐́@_ł͂Ȃ
//	͐̊0.01Ȃǂ̎ɗp
//	12345123.56Ӗ鎞 (d,3,2)Ǝw
void txbcd(int32_t d, byte n, byte p)
{
byte i, m;	
byte sgn = 0;		// tO
	memset(b_bff, ' ', sizeof(b_bff));	// Xy[XŖ߂
	if(d < 0){							// }CiX?
		d   = -d;
		sgn =  1;
	}
	m = n + p;						// + 
	for(i = 0; i < (sizeof(b_bff) - 2); i++){	  // }CiX̕c
		b_bff[i] = (d % 10) + '0';	// ʌ0`9
		d = d / 10;					// 1/10ďʌ̏
		if((d == 0) &&				// 0ɂȂI
		   (i >= p))		break;	// ok?
	}
	if(sgn){						// l}CiX?
		b_bff[i + 1] = '-';
	}	
	for(i = 0; i < m; i++){			// loop
		tx(b_bff[m - i - 1]);		// obt@tŏo
		if(p){						// o?
		  if(i == (m - p - 1))		tx('.');	// _
		}
	}
}

/********************************/
/*		^C}[荞		*/
/********************************/
//	^C}[f[^
volatile byte cnt_1ms;		// 1msŃJEgAbv
							// A/D̓^C~O1bvo߃`FbN
volatile byte tm_10ms;		// 10ms_EJEg^C}[
							// 9600BPS{[[g荞ݓŏ
/*****	^C}[1 : 9600BPS{[[g荞	*****/
//	18.432MHz / 8 / 240 = 9600Hz = 104.17us
//	VAo͏
//	tx_bffɕΏo͊Jn
//	OCF0A1mso߂`FbN
ISR(TIM1_COMPA_vect)
{
static volatile byte cnt_10 = 0;
	switch(tx_exc){
	  case 0:		// X^oC Mf[^҂
		if(tx_cnt){				// obt@ɕ?
		  TX_L;					// start bit L
		  tx_bit = 8;			// 8bitJE^
		  tx_exc = 2;			// f[^o͂
		  tx_chr = tx_bff[tx_rdp];	// 1[h
	      tx_rdp++;
		  if(tx_rdp >= TX_SIZ)		tx_rdp = 0;	// |C^?
		  tx_cnt--;				//  -1
	      tx_exc  = 1;			// startrbgo͂
		}
		break;
	  case 1:		// data 8bit LSBo
		if(tx_chr & 0x01)	TX_H;	// data H
	    else				TX_L;	// data L
		tx_chr >>= 1;				// EVtg
		tx_bit--;					// bit -1
		if(tx_bit == 0)		tx_exc = 2;	// 8bitstop bit
		break;
	  case 2:		// stop bit
		TX_H;					// Ho
		tx_exc = 0;				// stopoŃX^oC
		break;
	}
//	1ms  TIFR0OCF0A`FbN
	if(TIFR0 & (1 << OCF0A)){		// 1mso?
//		PA6_H;						// (!!!)
		TIFR0 = (1 << OCF0A);		// bitonătONA
		if(cnt_1ms < 255){			// max 255=0.255b
			cnt_1ms++;				// upJEg
		}
		cnt_10++;					// 10msv
		if(cnt_10 >= 10){
			cnt_10 = 0;
			if(tm_10ms)		tm_10ms--;	// 10ms^C}[ _EJEg
		}
//		PA6_L;						// (!!!)
	}
}

/********************************/
/*		CjV			*/
/********************************/
/*****	}CRI/Ȍ		*****/
//	NbN͊OtXTAL 18.432MHz
void initio(void)
{
    cli();                  // 荞݋֎~
//  I/OCjV
    PORTA = 0b10110000;     // data/pull up
    DDRA  = 0b11011100;     // portin/outw
    //        |||||||+----  PA0  in  AREF A/Dd 4.096V MCP1541
    //        ||||||+-----  PA1  in  ADC1 A/D Aϊ
    //        |||||+------  PA2  out ADC DIN (ADCւ̃R}h) 
    //        ||||+-------  PA3  out ADC CLK
    //        |||+--------  PA4  out TXD VAf[^o(^C}[荞݂ŏo)
    //        ||+---------  PA5  in  JP1 LœdA/DlƒRlt
    //        |+----------  PA6  out OC1A 4.8kHzo
    //        +-----------  PA7  out ADC /CS 
    PORTB = 0b00000100;     // data/pull up
    DDRB  = 0b00000000;     // portin/outw
    //            |||+----  PB0  -   X1 XTAL
    //            ||+-----  PB1  -   X2 XTAL
    //            |+------  PB2  in  ADC DOUT (ADC̃f[^)
    //            +-------  PB3  -   (RESET)
//	^C}[0  18.432/256/72 1kHz
//	1msvp
    TCCR0A = 0b00000010;  // [hݒ
    //         ||||  ++---  WGM01,02 CTC[h
    //         ||++-------  COM0B gp
    //         ++---------  COM0A gp
    TCCR0B = 0b00000100;  // NbNݒ
    //             |+++---  CS:1/256 72kHz
    //             +------  WGM02
    OCR0A  = 72 - 1;  		// 1/721kHz
							// 1ms^C}[ƂĎg
							// 荞݂ł͂ȂTIFR0OCF0A`FbN
//	^C}[1 : VAo̓{[[g (9600BPS)
//	18.432MHz / 8 / 240 = 9600Hz
    TCCR1A = 0b01000000;  	// [hݒ
	//         ||||  ++---  WGM11,10 CTC[h   
	//         ||++-------	COM1B gp
	//		   ++---------	COM1A OC1AgOo PA6
    TCCR1B = 0b00001010;  // NbNݒ
    //         || ||+++---  CS:1/8 2.304MHz
    //         || ++------  WGM13,12 CTC OCR1AŃRyA}b`
	//		   |+---------	ICES1
	//		   +----------	ICNC1
	OCR1A  = 240 - 1;		// 9600Hz
    TIMSK1 = 0b00000010;	// ^C}[荞
	//           |  ||+---	TOIE1
    //           |  |+---- 	OCIE1A ^C}[1 {[[g荞
    //           |  +-----	OCIE1B
    //           +--------	ICIE1
//	A/D
	DIDR0  = 0b00000011;	// fW^͋֎~
	//               |+---	ADC0D (PA0) AREF
	//		         +----	ADC1D (PA1) ADC1
	ADMUX  = 0b01000001;	// ch MPX
	//		   ||++++++---	MUX  : ADC1 PA1
	//		   ++----------	REFS : OAREF (4.096V)
	ADCSRB = 0b00000000;	// ϊgK
	//		   || | +++---	ADTS Free Run[h
	//		   || +-------	ADLAR El (LSBD0)
	//		   |+---------	ACME
	//		   +----------	BIN
	ADCSRA = 0b11100111;
	//		   |||||+++---	CLK 1/128 144kHz
	//		   ||||+------	ADIE  荞݂Ȃ
	//	       |||+-------	ADIF
	//	       ||+--------	ADATE gK
	//	       |+--------	ADSC  X^[g
	//		   +----------	ADEN  A/DCl[u
//	荞݊Jn
    sei();              	// 
}

/********************************/
/*		C[v			*/
/********************************/
//	f[^
uint32_t tx_nbr;			// 1bƂ̑Mԍ 6 0`999999
//	xch0`ch34@@ch4͓dl
short  thm_temp[AD_SU - 1];	// 0.1Pʂ̃T[~X^x(4ch)
float  thm_ohm[AD_SU - 1];	// T[~X^Rl
							// A/Dl ad_avr(0`4095)vZ
/*****	C		*****/
//	NINP_ADDO(PB4Wp)on(L)ȂA/Df[^`FbN̂
//	A/DlƒRlo͂ɉ
int main(void)
{
byte  i;
word  d;
byte  n;			// T[~X^x,R萔|C^
float r;			// T[~X^Rl
	initio();						// }CRI/Ȍ
	rt_max = 						// őRl(x)
		pgm_read_float(&thm_103JT[0].ohm);
	rt_min =						// ŏRl(x)
		pgm_read_float(&thm_103JT[DIMSIZ(thm_103JT) - 1].ohm);
	tm_10ms = 100;					// 1b҂
	while(tm_10ms);
	txstr_P(msg_ttl);				// ^CgVAo
//	loop
	while(1){				// loop
//	1ms^C}[ (cnt_1ms̓^C}[荞݂ŃJEgAbv)
//	VAo͂ȂǂŏxꂽƂcnt_1ms͗ݐς̂ŔȂ
	  if(cnt_1ms){					// 1mso?
		cli();						// 񊄂荞݋֎~
	    cnt_1ms--;					// -1ms
		sei();						// 荞ݗLɖ߂
		adavr();					// x,dA/D,ϒlvZ
									// 5ch200񕽋 =1b
//	1bo
		if(f_adok){					// 1bo߂ŕϒlm
		  f_adok = 0;				// A/Df[^񐔂Ōv
//	A/D xvZ ch0`ch34f[^, ch4͓A/D
		  for(i = 0; i < (AD_SU - 1); i++){	// RlAxvZ
			d = adadj(ad_avr[i], i);	// mapŕ d0`4095ŋK
			r = rthm(d, i);				// A/DlRlZo
		    if(r > rt_max){
				r = rt_max;				// őRl:Œቷx
			}
			else if(r < rt_min){
				r = rt_min;				// ŏRl:ōx
			}
			thm_ohm[i] = r;				// Rlۑ
			n = thmsearch(r);				// T[~X^萔̔zԍ
			thm_temp[i] = tempcalc(r, n);	// xvZ
		  }
//	f[^o
		  txbcd(tx_nbr, 6, 0);			// AԂ6ŏo
		  tx_nbr++;						// A+1
		  if(tx_nbr > 999999)	tx_nbr = 0; // 999999̎0
//	x + d
		  for(i = 0; i < (AD_SU - 1); i++){	// 4ch loop
			txbcd(thm_temp[i], 4, 1);		// x 0.1 -12.3`109.5
		  }
		  txbcd(adadj(ad_avr[AD_CH4],AD_CH4), 3, 2); // ch4:d 4.01
	      txcrlf();						// s
//	`FbNf[^o
		  if(INP_JP1){					// JP1Wp[on ?
			txstr_P(PSTR("# A/D "));		// A/Dl
		    for(i = 0; i < AD_SU; i++){		// 5ch loop
		  	  txbcd(ad_avr[i], 6, 0);		// A/Dϒl 0`4095
		    }
	        txcrlf();						// s
			txstr_P(PSTR("# R "));			// R
		    for(i = 0; i < (AD_SU - 1); i++){	// 4ch loop
			  txbcd((long)(thm_ohm[i] * 10.0), 7, 1);	// Rl
		    }
	        txcrlf();					// s
		  }
	    }
	  }
	}
}

/*=====	end of "tn84_thm4ch1.c"	=====*/

